package com.tofly.water.service;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.tofly.water.entity.BasePumpDetail;
import com.tofly.water.entity.DevicePump;
import com.tofly.water.entity.dto.BasePumpDetailDto;

import org.springframework.web.multipart.MultipartFile;

import java.io.Serializable;
import java.util.List;

/**
 * 水泵基础信息(BasePumpDetail)表服务接口
 *
 * @author HaiQiu
 * @since 2022-11-22 11:34:21
 */
public interface BasePumpDetailService extends IService<BasePumpDetail> {

    /**
     * 根据ID查询
     *
     * @param id id
     * @return 数据
     */
    BasePumpDetail get(Serializable id);

    /**
     * 新增
     *
     * @param basePumpDetailDto 实体
     */
    void insert(BasePumpDetailDto basePumpDetailDto);

    /**
     * 修改
     *
     * @param basePumpDetailDto 实体
     */
    void edit(BasePumpDetailDto basePumpDetailDto);

    /**
     * 批量删除
     *
     * @param idList 数据ID集合
     */
    void delete(List<Long> idList);

    /**
     * 生成模板下载
     */
    void template();

    /**
     * 数据导入
     *
     * @param file 文件
     */
    void importData(MultipartFile file);

    /**
     * 分页查询
     *
     * @param page           分页
     * @param basePumpDetail 查询wrapper
     * @return 数据集合
     */
    Page<BasePumpDetail> pageList(Page page, BasePumpDetail basePumpDetail);

    /**
     * 数据导出
     *
     * @param page           分页
     * @param basePumpDetail 查询模型
     * @param isAll          是否导出全部数据，true是，false否
     */
    void export(Page page, BasePumpDetail basePumpDetail, Boolean isAll);

    /**
     * 查询所有数据
     *
     * @param basePumpDetail 查询条件
     * @return 查询所有数据
     */
    List<BasePumpDetail> allList(BasePumpDetail basePumpDetail);
}

